/**********************************************************************

gssklog.h:

Description:
    This header file used internally by the gssklog routines

CVS Information:

    $Source: $
    $Date: $
    $Revision: $
    $Author: $

**********************************************************************/

#ifndef _gssklog_H
#define _gssklog_H
#ifdef  __cplusplus
extern "C" {
#endif

/**********************************************************************
                             Include header files
**********************************************************************/

#include <gssapi.h>
#include <afs/stds.h>

/**********************************************************************
                               Define constants
**********************************************************************/

/**********************************************************************
                               Type definitions
**********************************************************************/

/**********************************************************************
                               Global variables
**********************************************************************/

/**********************************************************************
                               Function prototypes
**********************************************************************/

afs_int32
create_request (
			unsigned char * req,
			int  *reqlen,
			char *cname,
			char *cinst,
			char *crealm,
			char *sname,
			char *sinst,
			char *srealm,
			afs_int32  lifetime);

int
process_response(unsigned char * resp, 
			size_t resplen,
            char * cell,
            char **reason, 
			int dosetpag);

int
parse_response(unsigned char * resp, size_t resplen,
                afs_uint32 * startTime,
                afs_uint32 * endTime,
                afs_int32 * afskvno,
                struct ktc_encryptionKey * sessionKey,
				struct ktc_principal * client,
				struct ktc_principal * server,
                unsigned char * ticket,
                int * ticketlen);
 
int
store_afs_token(
    struct ktc_principal *client,
	struct ktc_principal *server,
    afs_int32 tkt_type,  /* really AFS kvno for K4 */
    unsigned char *ticket_p,
    int ticket_len,
    struct ktc_encryptionKey * session_key,
    afs_int32 starttime,
    afs_int32 endtime,
    int set_pag);
    
afs_int32
ktohl_internal (char flags, afs_int32 l);

#endif  /* _gssklog_H */
