#
# WIN32 makefile: use with  'nmake -f gssklog.mak'
#


# Compiler (this will use Microsoft Visual C++, run VCVARS32.BAT in the
#           bin directory of that distribution to compiler correctly in
#           a DOS window)
CC=cl

#
# The source directory
#
SRC_D=.
# The output directory for everything intersting
BIN_D=$(SRC_D)\..\bin

# The output directory for all the temporary muck
OBJ_D=$(SRC_D)\..\obj

#DEE for src in AFS, and obj, bin on local machine
BIN_D=d:\build\bin
OBJ_D=d:\build\obj

#
# OPENAFS directories 
#
#AFS_INC_D=D:\build\openafs-1.2.2b\DEST\include
#AFS_LIB_D=D:\build\openafs-1.2.2b\DEST\lib
#AFS_INC_D=D:\build\openafs-1.2.10\DEST\include
#AFS_LIB_D=D:\build\openafs-1.2.10\DEST\lib
AFS_INC_D="C:\Program Files\OpenAFS\Client\Program\Include"
AFS_LIB_D="C:\Program Files\OpenAFS\Client\Program\Lib" 

AFS_CFLAGS=-DAFS_NT40_ENV

A_LIBS = \
		$(AFS_LIB_D)\afs\afsauth.lib \
		$(AFS_LIB_D)\afs\afspioctl.lib \
		$(AFS_LIB_D)\afs\afsutil.lib \
		$(AFS_LIB_D)\afs\afscmd.lib \
		$(AFS_LIB_D)\afsdes.lib \
		$(AFS_LIB_D)\libafsconf.lib
 
#
# GSS - We have our own gssapi.h and dynamicly load gssapi32.dll
#

LINK=link
LFLAGS= /nologo /subsystem:console /machine:I386 /opt:ref
WLFLAGS=/nologo /subsystem:windows /machine:I386 /opt:ref 

CP=copy
RM=del
RC=rc
RANLIB=
MKDIR=mkdir
MKLIB=lib
MLFLAGS= /nologo /subsystem:console /machine:I386 /opt:ref /dll

# Compiler flags...
#
# add /Zi and -DDEBUG for debug
CFLAG= /MD /W3  /G5 /Ox /O2 /Ob2 /Gs0 /GF /Gy /nologo -DWIN32 -DWIN32_LEAN_AND_MEAN 

#secur32.lib is the Security/sspi library 

EX_LIBS=wsock32.lib dnsapi.lib user32.lib gdi32.lib advapi32.lib secur32.lib


######################################################
# 
######################################################

INC=-I$(SRC_D)  -I$(AFS_INC_D) 
#
# Can also add -DDEBUG to the next three lines to print to stderr
#
APP_CFLAGS=$(INC) $(CFLAG) $(AFS_CFLAGS) 
RFLAGS=$(INC)


#############################################

E_OBJ=$(OBJ_D)\gssklog.obj \
	$(OBJ_D)\gssklog_afs.obj \
	$(OBJ_D)\gssklog_comm.obj  \
	$(OBJ_D)\gssklog_gss.obj \
	$(OBJ_D)\gssklog_sspi.obj \
	$(OBJ_D)\gssklog_wrpw.obj


###################################################################
all: banner $(OBJ_D) $(BIN_D) obj  exe


# application objects 

$(OBJ_D)\gssklog.obj: $(SRC_D)\gssklog.c
	$(CC) /Fo$(OBJ_D)\gssklog.obj $(APP_CFLAGS) $(INC) -c $(SRC_D)\gssklog.c

$(OBJ_D)\gssklog_afs.obj: $(SRC_D)\gssklog_afs.c
	$(CC) /Fo$(OBJ_D)\gssklog_afs.obj $(APP_CFLAGS) $(INC) -c $(SRC_D)\gssklog_afs.c

$(OBJ_D)\gssklog_comm.obj: $(SRC_D)\gssklog_comm.c
	$(CC) /Fo$(OBJ_D)\gssklog_comm.obj $(APP_CFLAGS) $(INC) -c $(SRC_D)\gssklog_comm.c

$(OBJ_D)\gssklog_gss.obj: $(SRC_D)\gssklog_gss.c
	$(CC) /Fo$(OBJ_D)\gssklog_gss.obj $(APP_CFLAGS) $(INC) -c $(SRC_D)\gssklog_gss.c

$(OBJ_D)\gssklog_sspi.obj: $(SRC_D)\gssklog_sspi.c
	$(CC) /Fo$(OBJ_D)\gssklog_sspi.obj $(APP_CFLAGS) $(INC) -c $(SRC_D)\gssklog_sspi.c


$(OBJ_D)\gssklog_wrpw.obj: $(SRC_D)\gssklog_wrpw.c
	$(CC) /Fo$(OBJ_D)\gssklog_wrpw.obj $(APP_CFLAGS) $(INC) -c $(SRC_D)\gssklog_wrpw.c

# appliction exes

$(BIN_D)\gssklog.exe: $(E_OBJ) 
        $(LINK) $(LFLAGS) /out:$(BIN_D)\gssklog.exe @<< 
	$(E_OBJ) $(A_LIBS) $(EX_LIBS)
<<

banner:

$(OBJ_D):
	$(MKDIR) $(OBJ_D)

$(BIN_D):
	$(MKDIR) $(BIN_D)


headers: $(HEADER)

lib: 

obj: $(E_OBJ)

exe:  $(BIN_D)\gssklog.exe

clean:
	$(RM) $(OBJ_D)\*.*

vclean:
	$(RM) $(OBJ_D)\*.*
	$(RM) $(BIN_D)\*.*
	


