/**********************************************************************

gssklogg.h:

Description:
    This header file used internally by the gssklog routines

CVS Information:

    $Source: $
    $Date: $
    $Revision: $
    $Author: $

**********************************************************************/

#ifndef _gssklogd_H
#define _gssklogd_H
#ifdef  __cplusplus
extern "C" {
#endif

/**********************************************************************
                             Include header files
**********************************************************************/

#include <afs/stds.h>
#include <rx/rxkad.h>

/**********************************************************************
                               Define constants
**********************************************************************/

#define MAX_ENTERPRISE_REALMS 11

/**********************************************************************
                               Type definitions
**********************************************************************/

/**********************************************************************
                               Global variables
**********************************************************************/

/**********************************************************************
                               Function prototypes
**********************************************************************/

char *
init_afs_local_cell_name();

int 
get_afs_key_from_file( char * afskeyfile,
            afs_int32  *afskvno,
            struct ktc_encryptionKey *afskey);

int
process_req(unsigned char * req,
            int reqlen,
            afs_int32 peer,
            char * afskeyfile,
            char * subject_name,
            char * rname,
            int glifetime,
			long int maxtktlifetime,
            unsigned char ** resp,
            size_t * resplen);

afs_int32 
ktohl (char flags, afs_int32 l);

#endif  /* _gssklogd_H */
